/*
 Fbus Checksum and Output Generator
 Version: 0.1
 Author: Alex from insideGadgets (http://www.insidegadgets.com)
 Created: 2/01/2013
 Last Modified: 6/01/2013
 
 Modify the FBusFrame array with the packet you want to sent to the phone and the checksum will be calculated and
 the frame will be outputted in hex
 
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

// An example of sending a phone the HW&SW version request
unsigned char FBusFrame[] = {
0x1E, // Using Fbus (leave as is)
0x00, // From Fbus (leave as is)
0x0C, // To Phone (leave as is)

0xD1, // Msg type

0x00, 0x00, // Frame length (is auto generated)
0x00, 0x01, // Unknown (leave as is)

// Start data/command to send
0x00,
0x03,
0x00,
// End

0x01, // Frames to go
0x60, // Sequence number (leave as is)

0x00, 0x00, 0x00 // Padding byte (if needed) and 2 checksums will be autogenerated
};

int main(int argc, char **argv) {
	
	// Size of array
	int Fbussize = sizeof(FBusFrame)/sizeof(unsigned char);
	
	// Calculate length
	FBusFrame[5] = Fbussize - 9;
	
	// Calculate checksum
	int oddCheckSum = 0, evenCheckSum = 0;
	int i;
	for (i = 0; i <= Fbussize-2; i += 2) {
		oddCheckSum ^= FBusFrame [i];
		evenCheckSum ^= FBusFrame [i+1];
	}
	
	// Check if odd or even and adjust padding
	if (FBusFrame[5] & 0x01) {
		FBusFrame[Fbussize-2] = oddCheckSum;
		FBusFrame[Fbussize-1] = evenCheckSum;
	}
	else {
		FBusFrame[Fbussize-3] = oddCheckSum;
		FBusFrame[Fbussize-2] = evenCheckSum;
		Fbussize--;
	}

	for (i = 0; i < Fbussize; i++) {
		printf("0x%.2X,\n", FBusFrame[i]);
	}
	
	return 0;
}
 
